

((PlbToolsApp createSubApplication: #PlbCustomDeepCopySupport in: '"VisualAge" System vmType = ''ES''') isNil)
    ifTrue: [SubApplication errorCouldNotCreate: #PlbCustomDeepCopySupport]!

PlbCustomDeepCopySupport becomeDefault!
Object subclass: #PlbCopyStrategy
    instanceVariableNames: 'visited structureCopyBlock contentsCopyBlock '
    classVariableNames: ''
    poolDictionaries: ''!

PlbCustomDeepCopySupport becomeDefault!
SubApplication subclass: #PlbCustomDeepCopySupport
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!


PlbCustomDeepCopySupport becomeDefault!

!Object privateMethods !

plbBasicCopyContentsFrom: original using: copyStrategy
	"Populate the variable slots of the receiver with copies of each variable
	 slot of original created under the control of copyStrategy."

	1 to: self class instSize do: [ :instVarIndex |
		self
			instVarAt: instVarIndex
			put: (copyStrategy copy: (original instVarAt: instVarIndex))
	].
	1 to: self basicSize do: [ :index |
		self 
			basicAt: index 
			put: (copyStrategy copy: (original basicAt: index))
	].
!

plbBasicCopyStructure
	"Answer an unpopulated instance like the receiver. This 
	 skeleton instance will later be populated as each referenced
	 variable of the receiver is copied. Answer nil or the receiver
	 if the receiver shouldn't be copied."

	^self class isVariable
		ifTrue: [ self class basicNew: self basicSize ]
		ifFalse: [ self class basicNew ]
! !

!PlbCopyStrategy class publicMethods !

new
	"Answer a new instance of the receiver with a number
	 of preallocated slots for unique objects."

	^self new: 32
!

new: uniqueObjectEstimate
	"Answer a new instance of the receiver with a number
	 of preallocated slots for unique objects."

	^self basicNew initialize: uniqueObjectEstimate
! !

!PlbCopyStrategy publicMethods !

contentsCopyBlock: twoArgBlock
	"Set a two argument block to use for copying
	 the contents of each object. The first argument
	 is the original object. The second argument is a
	 new empty object like the original."

	contentsCopyBlock := twoArgBlock!

copy: anObject

	^visited 
		at: anObject 
		ifAbsent: [ self createCopyOf: anObject ].!

copyRoot: anObject
	"This method is only used for the first object of
	 an object tree. It can be overridden for special
	 processing."

	^self copy: anObject
!

structureCopyBlock: oneArgBlock
	"Set an one argument block to use for copying
	 the structure of each object. The first argument
	 will be the original object to copy."

	structureCopyBlock := oneArgBlock! !

!PlbCopyStrategy privateMethods !

createCopyOf: anObject
	"Answer a copy of anObject after adding it to a 
	 collection of copied objects."

	| copy | 
	copy := visited
		at: anObject
		put: (structureCopyBlock value: anObject).
	copy == anObject ifTrue: [ ^anObject ].
	copy isNil ifFalse: [ contentsCopyBlock value: anObject value: copy ].
	^copy
!

initialize: uniqueObjectEstimate
	"Set visited to a collection that can be used to identify
	 objects that were already copied."

	visited := IdentityDictionary new: uniqueObjectEstimate.
! !

PlbCopyStrategy initializeAfterLoad!
PlbCustomDeepCopySupport initializeAfterLoad!

PlbCustomDeepCopySupport loaded!