

((PlbCustomDeepCopySupport createSubApplication: #PlbVisualAgeGeneralCopySupport in: 'true') isNil)
    ifTrue: [SubApplication errorCouldNotCreate: #PlbVisualAgeGeneralCopySupport]!

PlbVisualAgeGeneralCopySupport becomeDefault!
SubApplication subclass: #PlbVisualAgeGeneralCopySupport
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!


PlbVisualAgeGeneralCopySupport becomeDefault!

!Behavior privateMethods !

plbGeneralCopyStructure
	"Behaviors shouldn't generally be copied.
	 Answer the receiver."

	^self
! !

!CompiledMethod privateMethods !

plbGeneralCopyStructure
	"Compiled code shouldn't generally be copied.
	 Answer the receiver."

	^self
! !

!Context privateMethods !

plbGeneralCopyStructure
	"Contexts shouldn't generally be copied.
	 Answer the receiver."

	^self
! !

!EsPoolDictionary privateMethods !

plbGeneralCopyStructure
	"PoolDictionaries shouldn't generally be copied.
	 Answer the receiver."

	^self
! !

!EsSmalltalkDictionary privateMethods !

plbGeneralCopyStructure
	"The system dictionary shouldn't generally be copied.
	 Answer the receiver."

	^self
! !

!EsSmalltalkNamespace privateMethods !

plbGeneralCopyStructure
	"The system dictionary shouldn't generally be copied.
	 Answer the receiver."

	^self
! !

!Number privateMethods !

plbGeneralCopyStructure
	"Answer the receiver because operations on
	 numbers always create new numbers."

	^self
! !

!Object publicMethods !

plbGeneralCopy
	"Answer a true deep copy of the receiver while maintaining
	 references. Each referenced object will have the opportunity
	 to participate in the copy and decide how it should be copied."

	| copyStrategy |
	^(copyStrategy := PlbCopyStrategy new)
		structureCopyBlock: [:original | original plbGeneralCopyStructure ];
		contentsCopyBlock: [:original :skeleton | skeleton plbGeneralCopyContentsFrom: original using: copyStrategy ];
		copyRoot: self.
! !

!Object privateMethods !

plbGeneralCopyContentsFrom: original using: copyStrategy
	"Populate the variable slots of the receiver with copies of each variable
	 slot of original created under the control of copyStrategy."

	self plbVendorCopyContentsFrom: original using: copyStrategy
!

plbGeneralCopyStructure
	"Answer an unpopulated instance like the receiver. This 
	 skeleton instance will later be populated as each referenced
	 variable of the receiver is copied. Answer nil or the receiver
	 if the receiver shouldn't be copied."

	^self plbVendorCopyStructure
! !

!String privateMethods !

plbGeneralCopyStructure
	"Since strings are rarely modified by #at:put:, the
	 general behavior is to just answer the receiver."

	^self! !

PlbVisualAgeGeneralCopySupport initializeAfterLoad!

PlbVisualAgeGeneralCopySupport loaded!