'From VisualWorks(R), Release 2.5.1 of September 26, 1995 on February 10, 1998 at 6:44:07 am'!



((PlbCustomDeepCopySupport createSubApplication: #PlbVisualWorksVendorCopySupport in: 'true') isNil)
    ifTrue: [self error: 'Can not proceed since the sub-application was not created']!

PlbVisualWorksVendorCopySupport becomeDefault!

    "Private Class"
SubApplication subclass: #PlbVisualWorksVendorCopySupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''!

PlbVisualWorksVendorCopySupport becomeDefault!

!ArrayedCollection privateMethodsFor: 'copying'!

plbVendorCopyContentsFrom: original using: copyStrategy
	"Populate the variable slots of the receiver with copies of each variable
	 slot of original created under the control of copyStrategy."

	| item |
	1 to: original size do: [:index |
		item := original at: index.
		self at: index put: (copyStrategy copy: item)
	].! !

!Boolean privateMethodsFor: 'copying'!

plbVendorCopyStructure
	"Booleans shouldn't be copied. Just answer the receiver."

	^self! !

!Character privateMethodsFor: 'copying'!

plbVendorCopyStructure
	"Characters shouldn't be copied. Just answer the receiver."

	^self! !

!Collection privateMethodsFor: 'copying'!

plbVendorCopyContentsFrom: original using: copyStrategy
	"Populate the the receiver with copies of each element
	 of original created under the control of copyStrategy."

	original do: [:item| self add: (copyStrategy copy: item)].!

plbVendorCopyStructure
	"Answer an unpopulated instance like the receiver. This 
	 skeleton instance will later be populated as each referenced
	 variable of the receiver is copied."

	^self class new: self size! !

!Dictionary privateMethodsFor: 'copying'!

plbVendorCopyContentsFrom: original using: copyStrategy
	"Populate the receiver with copies of each element
	 of original created under the control of copyStrategy."

	original associationsDo: [:assoc | 
		self 
			at: assoc key
			put: (copyStrategy copy: assoc value)
	].! !

!Interval privateMethodsFor: 'copying'!

plbVendorCopyContentsFrom: original using: copyStrategy
	"Do nothing because the structure copy already copied the contents."!

plbVendorCopyStructure
	"Answer a standard copy of the receiver."

	^self copy! !

!Number privateMethodsFor: 'copying'!

plbVendorCopyContentsFrom: original using: copyStrategy
	"This method will only be run if a subclass of Number is created
	 that does not answer self when asked for a copy. The
	 situation is unlikely."!

plbVendorCopyStructure
	"Answer a standard copy of the receiver."

	^self copy! !

!Object publicMethodsFor: 'copying'!

plbVendorCopy
	"Answer a true deep copy of the receiver while maintaining
	 references. Each referenced object will have the opportunity
	 to participate in the copy and decide how it should be copied."

	| copyStrategy |
	^(copyStrategy := PlbCopyStrategy new)
		structureCopyBlock: [:original | original plbVendorCopyStructure ];
		contentsCopyBlock: [:original :skeleton | skeleton plbVendorCopyContentsFrom: original using: copyStrategy ];
		copyRoot: self.! !

!Object privateMethodsFor: 'copying'!

plbVendorCopyContentsFrom: original using: copyStrategy
	"Populate the variable slots of the receiver with copies of each variable
	 slot of original created under the control of copyStrategy."

	self plbBasicCopyContentsFrom: original using: copyStrategy!

plbVendorCopyStructure
	"Answer an unpopulated instance like the receiver. This 
	 skeleton instance will later be populated as each referenced
	 variable of the receiver is copied. Answer nil or the receiver
	 if the receiver shouldn't be copied."

	^self plbBasicCopyStructure! !

!SortedCollection privateMethodsFor: 'copying'!

plbVendorCopyStructure
	"Answer an unpopulated instance using the
	 same sort block as the receiver."

	^self class sortBlock: self sortBlock! !

!String privateMethodsFor: 'copying'!

plbVendorCopyContentsFrom: original using: copyStrategy
	"Do nothing because the string has already been copied."!

plbVendorCopyStructure
	"Answer a standard copy of the receiver."

	^self copy! !

!Symbol privateMethodsFor: 'copying'!

plbVendorCopyStructure
	"Symbols shouldn't be copied. Just answer the receiver."

	^self! !

!UndefinedObject privateMethodsFor: 'copying'!

plbVendorCopyStructure
	"The nil instance shouldn't be copied. Just answer the receiver."

	^self! !

!VariableBinding privateMethodsFor: 'copying'!

plbVendorCopyStructure
	"VariableBindings shouldn't be copied. Just answer the receiver."

	^self! !

PlbVisualWorksVendorCopySupport initializeAfterLoad!

PlbVisualWorksVendorCopySupport loaded!
